default:
  image: python:3.7
  before_script:
    - apt-get update
    - apt-get install -y python3-pip
    - pip install -r requirements.txt

variables:
  PYTHON_TAG: py3
  ABI_TAG: none
  PLATFORM_TAG: any
  PACKAGE_EXTENSION: whl

stages:
  - test
  - build
  - deploy

test:
  stage: test
  script:
    - pip install pytest-cov
    - coverage run -m pytest
    - coverage report
    - pytest --junitxml=report.xml

  only:
    - branches
    - tags
  tags:
    - shared-fi
  artifacts:
    when: always
    reports:
      junit: report.xml
    paths:
      - dist
    expire_in: 1 day

build:
  stage: build
  script:
    - python3 setup.py bdist_wheel
  only:
    - branches
    - tags
  tags:
    - shared-fi
  artifacts:
    paths:
      - dist
    expire_in: 1 day

deploy:
  stage: deploy
  script:
    - echo "[distutils]" >> ~/.pypirc
    - echo "index-servers = gitlab" >> ~/.pypirc
    - echo "[gitlab]" >> ~/.pypirc
    - space=" "
    - echo "repository :$space https://gitlab.fi.muni.cz/api/v4/projects/14820/packages/pypi" >> ~/.pypirc
    - echo "username = __token__" >> ~/.pypirc
    - echo "password = $api_token" >> ~/.pypirc
    - python3 -m pip install --user --upgrade twine
    #- echo 'import requests,sys' >> remover.py
    #- echo "requests.delete('https://gitlab.fi.muni.cz/api/v4/projects/14820/packages/'+str(requests.get('https://gitlab.fi.muni.cz/api/v4/projects/14820/packages', headers={'PRIVATE-TOKEN':sys.argv[1],}).json()[-1]['id']), headers={'PRIVATE-TOKEN':sys.argv[1],})" >> remover.py
    #- python3 -m pip install requests
    #- python3 remover.py $api_token
    - python -m twine upload --repository gitlab dist/*
  dependencies:
    - build
  only:
    - tags
    - branches
  tags:
    - shared-fi
